## gromacs 5.0.2

=== CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright (c) 2009,2010,2011,2012,2013,2014, by the GROMACS development team, led by
# Mark Abraham, David van der Spoel, Berk Hess, and Erik Lindahl,
# and including many others, as listed in the AUTHORS file in the
# top-level source directory and at http://www.gromacs.org.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# http://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at http://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out http://www.gromacs.org.

cmake_minimum_required(VERSION 2.8.8)
# When we require cmake >= 2.8.12, it will provide
# CMAKE_MINIMUM_REQUIRED_VERSION automatically, but in the meantime we
# need to set a variable, and it must have a different name.
set(GMX_CMAKE_MINIMUM_REQUIRED_VERSION "2.8.8")

# CMake modules/macros are in a subdirectory to keep this file cleaner
# This needs to be set before project() in order to pick up toolchain files
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Platform)

project(Gromacs)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# PROJECT_VERSION should have the following structure:
# VERSION-dev[-SUFFIX] where the VERSION should have the for: vMajor.vMinor.vPatch
#
# The "-dev" suffix is important to keep because it makes possible to distinguish
# between a build from official release and a build from git release branch on a
# machine with no git.
#
# NOTE: when releasing the "-dev" suffix needs to be stripped off!
# REGRESSIONTEST_VERSION and REGRESSIONTEST_BRANCH should always be
# defined.
set(PROJECT_VERSION "5.0.2")
# If this is a released tarball, "-dev" will not be present in
# PROJECT_VERSION, and REGRESSIONTEST_VERSION specifies the version
# number of the regressiontest tarball against which the code tarball
# can be tested. This will be the version of the last patch release.
set(REGRESSIONTEST_VERSION "5.0.2")
# The MD5 checksum of the regressiontest tarball. Only used if "-dev"
# is not present in the PROJECT_VERSION
set(REGRESSIONTEST_MD5SUM "004f2377adf252e2caa9c241390d4b9c")
# If this is not a released tarball, "-dev" will be present in
# PROJECT_VERSION, and REGRESSIONTEST_BRANCH specifies the name of the
# gerrit.gromacs.org branch whose HEAD can test this code, *if* this
# code contains all recent fixes from the corresponding code branch.
set(REGRESSIONTEST_BRANCH "refs/heads/release-5-0")

set(CUSTOM_VERSION_STRING ""
    CACHE STRING "Custom version string (if empty, use hard-coded default)")
mark_as_advanced(CUSTOM_VERSION_STRING)
if (CUSTOM_VERSION_STRING)
    set(PROJECT_VERSION ${CUSTOM_VERSION_STRING})
endif()
set(LIBRARY_SOVERSION 0)
set(LIBRARY_VERSION ${LIBRARY_SOVERSION}.0.0)
# It is a bit irritating, but this has to be set separately for now!
SET(CPACK_PACKAGE_VERSION_MAJOR "5")
SET(CPACK_PACKAGE_VERSION_MINOR "0")
#SET(CPACK_PACKAGE_VERSION_PATCH "0")

# The numerical gromacs version. It is 40600 for 4.6.0.
# The #define GMX_VERSION in gromacs/version.h is set to this value.
math(EXPR NUM_VERSION
    "${CPACK_PACKAGE_VERSION_MAJOR}*10000 + ${CPACK_PACKAGE_VERSION_MINOR}*100")
if(CPACK_PACKAGE_VERSION_PATCH)
    math(EXPR NUM_VERSION
         "${NUM_VERSION} + ${CPACK_PACKAGE_VERSION_PATCH}")
endif()

# The API version tracks the numerical Gromacs version (for now).
# It is potentially different from the Gromacs version in the future, if
# the programs/libraries diverge from the presumably more stable API.
# The #define GMX_API_VERSION in version.h is set to this value to
# provide backward compatibility of software written against the Gromacs API.
set(API_VERSION ${NUM_VERSION})

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND UNIX)
    set(CMAKE_INSTALL_PREFIX "/usr/local/gromacs" CACHE STRING "Installation prefix (installation will need write permissions here)" FORCE)
endif()

include(gmxBuildTypeReference)
include(gmxBuildTypeTSAN)
include(gmxBuildTypeASAN)
include(gmxBuildTypeReleaseWithAssert)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel Reference RelWithAssert." FORCE)
    # There's no need to offer a user the choice of ThreadSanitizer
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
        "MinSizeRel" "RelWithDebInfo" "Reference" "RelWithAssert")
endif()
if(CMAKE_CONFIGURATION_TYPES)
    # Add appropriate GROMACS-specific build types for the Visual
    # Studio generator (Debug, Release, MinSizeRel and RelWithDebInfo
    # are already present by default).
    list(APPEND CMAKE_CONFIGURATION_TYPES "RelWithAssert" "Reference")
    list(REMOVE_DUPLICATES CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING
        "List of configuration types"
        FORCE)
endif()
set(build_types_with_explicit_flags RELEASE DEBUG RELWITHDEBINFO RELWITHASSERT MINSIZEREL)

enable_language(C)
enable_language(CXX)
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS ON)

set(CPACK_PACKAGE_NAME "gromacs")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_PACKAGE_VENDOR "gromacs.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Gromacs - a toolkit for high-performance molecular simulation")
set(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/admin/InstallWelcome.txt")
# Its GPL/LGPL, so they do not have to agree to a license for mere usage, but some installers require this...
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/admin/InstallInfo.txt")
set(CPACK_SOURCE_IGNORE_FILES "\\\\.isreposource$;\\\\.git/;\\\\.gitignore$;\\\\.gitattributes;")
set(CPACK_PROJECT_CONFIG_FILE "${CMAKE_SOURCE_DIR}/CPackInit.cmake")
# CPack source archives include only the directories we list here.
# This variable is a list of pairs of names of source and destination
# directories. Most of these are used for content GROMACS generates as
# part of the configuration or build.
set(CPACK_SOURCE_INSTALLED_DIRECTORIES "${CMAKE_SOURCE_DIR};/;${CMAKE_BINARY_DIR}/src/programs/completion;src/programs/completion;${CMAKE_BINARY_DIR}/docs/man/man1;docs/man/man1;${CMAKE_BINARY_DIR}/docs/man/man7;docs/man/man7;${CMAKE_BINARY_DIR}/docs/old-html/final;docs/old-html/final;${CMAKE_BINARY_DIR}/docs/install-guide/final;/")
set(CPACK_PACKAGE_CONTACT "gmx-users@gromacs.org")
set(CPACK_GMX_BUILD_HELP "${GMX_BUILD_HELP}") #Works even though GMX_BUILD_HELP is defined later because it is off by default.

#must come after all cpack settings!
include(CPack)

# Set a default valgrind suppression file.
# This unfortunately needs to duplicate information from CTest to work as
# expected...
set(MEMORYCHECK_SUPPRESSIONS_FILE
    "${CMAKE_SOURCE_DIR}/cmake/legacy_and_external.supp"
    CACHE FILEPATH
    "File that contains suppressions for the memory checker")
include(CTest)

set(SOURCE_IS_GIT_REPOSITORY OFF)
set(SOURCE_IS_SOURCE_DISTRIBUTION OFF)
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    set(SOURCE_IS_GIT_REPOSITORY ON)
endif()
if(NOT EXISTS "${CMAKE_SOURCE_DIR}/admin/.isreposource")
    set(SOURCE_IS_SOURCE_DISTRIBUTION ON)
endif()

########################################################################
# Check and warn if cache generated on a different host is being reused
########################################################################
if(CMAKE_HOST_UNIX)
    execute_process(COMMAND hostname
                    OUTPUT_VARIABLE TMP_HOSTNAME
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(GMX_BUILD_HOSTNAME AND NOT "${GMX_BUILD_HOSTNAME}" STREQUAL "${TMP_HOSTNAME}")
        message(WARNING "
            The CMake cache, probably generated on a different host (${GMX_BUILD_HOSTNAME}),
            is being reused! This could lead to inconsitencies; therefore, it is
            recommended to regenerate the cache!")
    endif()
    set(GMX_BUILD_HOSTNAME "${TMP_HOSTNAME}" CACHE INTERNAL
            "Hostname of the machine where the cache was generated.")
endif()

########################################################################
# Detect architecture before setting options so we can alter defaults
########################################################################
# Detect the architecture the compiler is targetting, detect
# SIMD instructions possibilities on that hardware, suggest SIMD instruction set
# to use if none is specified, and populate the cache option for CPU
# SIMD.
include(gmxDetectTargetArchitecture)
gmx_detect_target_architecture()

########################################################################
# User input options                                                   #
########################################################################
include(gmxOptionUtilities)

set(CMAKE_PREFIX_PATH "" CACHE STRING "Extra locations to search for external libraries and tools (give directory without lib, bin, or include)")

if(GMX_TARGET_FUJITSU_SPARC64)
    # Fujitsu only has SIMD in double precision, so this will be faster
    set(GMX_DOUBLE_DEFAULT ON)
else()
    set(GMX_DOUBLE_DEFAULT OFF)
endif()
option(GMX_DOUBLE "Use double precision (much slower, use only if you really need it)" ${GMX_DOUBLE_DEFAULT})
option(GMX_RELAXED_DOUBLE_PRECISION "Accept single precision 1/sqrt(x) when using Fujitsu HPC-ACE SIMD" OFF)
mark_as_advanced(GMX_RELAXED_DOUBLE_PRECISION)

option(GMX_MPI    "Build a parallel (message-passing) version of GROMACS" OFF)
option(GMX_THREAD_MPI  "Build a thread-MPI-based multithreaded version of GROMACS (not compatible with MPI)" ON)
gmx_dependent_option(
    GMX_MPI_IN_PLACE
    "Enable MPI_IN_PLACE for MPIs that have it defined"
    ON
    GMX_MPI)
mark_as_advanced(GMX_MPI_IN_PLACE)
option(GMX_SOFTWARE_INVSQRT "Use GROMACS software 1/sqrt" ON)
mark_as_advanced(GMX_SOFTWARE_INVSQRT)
option(GMX_FAHCORE "Build a library with mdrun functionality" OFF)
mark_as_advanced(GMX_FAHCORE)

option(GMX_COOL_QUOTES "Enable Gromacs cool quotes" ON)
mark_as_advanced(GMX_COOL_QUOTES)
gmx_add_cache_dependency(GMX_COOL_QUOTES BOOL "NOT GMX_FAHCORE" OFF)

# Decide on GPU settings based on user-settings and GPU/CUDA detection.
# We support CUDA >=v4.0 on *nix, but <= v4.1 doesn't work with MSVC
if(MSVC)
    set(REQUIRED_CUDA_VERSION 4.1)
else()
    set(REQUIRED_CUDA_VERSION 4.0)
endif()
set(REQUIRED_CUDA_COMPUTE_CAPABILITY 2.0)
include(gmxManageGPU)

if(GMX_CPU_ACCELERATION)
    # Stay compatible with old Jenkins command line options for specific SIMD acceleration

=== src/external/gmock-1.7.0/CMakeLists.txt ===
#
# This file is part of the GROMACS molecular simulation package.
#
# Copyright (c) 2011,2012,2013,2014, by the GROMACS development team, led by
# Mark Abraham, David van der Spoel, Berk Hess, and Erik Lindahl,
# and including many others, as listed in the AUTHORS file in the
# top-level source directory and at http://www.gromacs.org.
#
# GROMACS is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# GROMACS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with GROMACS; if not, see
# http://www.gnu.org/licenses, or write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
#
# If you want to redistribute modifications to GROMACS, please
# consider that scientific software is very special. Version
# control is crucial - bugs must be traceable. We will be happy to
# consider code for inclusion in the official distribution, but
# derived work must not be called official GROMACS. Details are found
# in the README & COPYING files - if they are missing, get the
# official version at http://www.gromacs.org.
#
# To help us fund GROMACS development, we humbly ask that you cite
# the research papers on the package. Check out http://www.gromacs.org.

# As stated in README.Gromacs, this file is not part of GMock, but is written
# specifically for the GROMACS build system from scratch.

include(gmxGetGmockTupleWorkaround)
get_gmock_tuple_workaround(GMOCK_COMPILE_DEFINITIONS)
set(GMOCK_COMPILE_DEFINITIONS "_GNU_SOURCE=1;${GMOCK_COMPILE_DEFINITIONS}")
set(GMOCK_COMPILE_DEFINITIONS ${GMOCK_COMPILE_DEFINITIONS} PARENT_SCOPE)

# GTest/GMock suggest linking with pthreads when available for thread safety
set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
set(PTHREADS_LIBRARIES)
if (CMAKE_USE_PTHREADS_INIT)
    set(PTHREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif()

set(GMOCK_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(GTEST_DIR ${GMOCK_DIR}/gtest)
set(GTEST_SOURCES ${GTEST_DIR}/src/gtest-all.cc)
set(GMOCK_SOURCES ${GMOCK_DIR}/src/gmock-all.cc)

set(GTEST_INCLUDE_DIRS ${GTEST_DIR}/include)
set(GMOCK_INCLUDE_DIRS ${GMOCK_DIR}/include ${GTEST_INCLUDE_DIRS})

include_directories(BEFORE ${GTEST_INCLUDE_DIRS})
include_directories(BEFORE ${GTEST_DIR})
include_directories(BEFORE ${GMOCK_INCLUDE_DIRS})
include_directories(BEFORE ${GMOCK_DIR})

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wno-unused-variable HAS_NO_UNUSED_VARIABLE)
if (HAS_NO_UNUSED_VARIABLE)
    set_source_files_properties(${GTEST_SOURCES} PROPERTIES COMPILE_FLAGS "-Wno-unused-variable")
endif()

add_library(gmock STATIC ${UNITTEST_TARGET_OPTIONS} ${GMOCK_SOURCES} ${GTEST_SOURCES})
set_property(TARGET gmock APPEND PROPERTY COMPILE_DEFINITIONS "${GMOCK_COMPILE_DEFINITIONS}")

set(GMOCK_LIBRARIES gmock ${PTHREADS_LIBRARIES} PARENT_SCOPE)
set(GTEST_LIBRARIES ${GMOCK_LIBRARIES} PARENT_SCOPE)
set(GMOCK_INCLUDE_DIRS ${GMOCK_INCLUDE_DIRS} PARENT_SCOPE)
set(GTEST_INCLUDE_DIRS ${GTEST_INCLUDE_DIRS} PARENT_SCOPE)

=== debian/changelog ===
gromacs (5.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 3.9.6, no changes required.
  * Update rules to build GPU-accelerated packages, with thanks to
    Steffen Möller.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 05 Oct 2014 10:29:34 -0700

gromacs (5.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Rebase patches involving man pages (moved from share/man to doc/man in
    tarball), drop 20_random123_platforms.patch (incorporated upstream),
    and remove the leading numbers from all patch filenames (a leftover from
    dpatch).
  * man/mdrun_mpi.*: Update .TH line.
  * rules: Set CMAKE_RULE_MESSAGES=OFF to work around blhc false positives
    for "W-compiler-flags-hidden".
  * Move debian/upstream to debian/upstream/metadata.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 06 Sep 2014 11:20:17 -0700

gromacs (5.0-3) unstable; urgency=medium

  * Upload to unstable.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 24 Aug 2014 20:02:24 -0700

gromacs (5.0-2) experimental; urgency=low

  * Add 20_random123_platforms.patch to disable architecture check from
    external Random123 code.
  * Drop discussion of shared libraries from README.Debian for
    gromacs-{mpich,openmpi}.

 -- Nicholas Breen <nbreen@debian.org>  Wed, 02 Jul 2014 20:13:01 -0700

gromacs (5.0-1) experimental; urgency=low

  * New upstream release, experimental upload.
    - g_sigeps / gmx sigeps command line handling no longer crashes on
      invalid input (Closes: #715935).
  * Rebase existing patches.  Add new patches:
    - 31_manpage_hyphenation.patch: Some parts of the man page generation
      get the hyphen/dash separation right, some don't.  A temporary fix
      pending significant overhaul of the man page system.
      <http://redmine.gromacs.org/issues/1437>
    - 32_spelling.patch: Correction of minor spelling errors.
  * man/g_{dos,kinetics,luck}.1: Incorporated upstream, removed.
  * man/gmx.1: Rudimentary man page written and added.
  * man/mdrun_mpi.*.1: Updated with text from upstream gmx-mpich.1.
  * rules: Updates for MPI builds and assorted upstream changes.
  * gromacs-data.lintian-overrides, source/lintian-overrides: Removed.
  * Add Build-Depends on external libboost-dev.
  * Switch away from hardening-wrapper in favor of dpkg-buildflags.
  * Update copyright file.

 -- Nicholas Breen <nbreen@debian.org>  Wed, 02 Jul 2014 17:35:18 -0700

=== debian/control ===
Source: gromacs
Section: science
Priority: extra
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Nicholas Breen <nbreen@debian.org>
Build-Depends: debhelper (>= 7.0.0), libfftw3-dev, libmpich-dev (>= 3.0.4-6), libopenmpi-dev (>= 1.2.4-5) [alpha amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el sparc sparc64], libx11-dev, zlib1g-dev, libgsl0-dev, libxml2-dev, libblas-dev, liblapack-dev, libboost-dev, cmake
Standards-Version: 3.9.6
Homepage: http://www.gromacs.org/
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/gromacs/

Package: gromacs
Architecture: any
Depends: gromacs-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: cpp
Suggests: pymol
Description: Molecular dynamics simulator, with building and analysis tools
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.

Package: gromacs-data
Architecture: all
Depends: ${misc:Depends}
Recommends: gromacs
Suggests: tcsh | c-shell
Conflicts: gromacs-doc
Breaks: gromacs (<< 3.3.3-1)
Replaces: gromacs-doc
Description: GROMACS molecular dynamics sim, data and documentation
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains architecture-independent topology and force field
 data, documentation, man pages, and example files.

Package: gromacs-dev
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, gromacs (= ${binary:Version}), fftw3-dev, ${misc:Depends}
Recommends: gromacs-data
Suggests: gromacs-mpich (= ${binary:Version}) | gromacs-openmpi (= ${binary:Version}) [alpha amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el sparc sparc64], libmpich-dev, libx11-dev, zlib1g-dev
Description: GROMACS molecular dynamics sim, development kit
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains header files and static libraries for development
 purposes, plus sample Makefiles.  Development components for MPI-enabled
 GROMACS builds also require their respective packages.

Package: gromacs-mpich
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mpich
Recommends: gromacs
Suggests: gromacs-data
Replaces: gromacs-dev (<< 4.6.3-3~)
Breaks: gromacs-dev (<< 4.6.3-3~)
Description: Molecular dynamics sim, binaries for MPICH parallelization
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains only the core simulation engine with parallel
 support using the MPICH (v3) interface.  It is suitable for nodes of a
 processing cluster, or for multiprocessor machines.

Package: gromacs-openmpi
Architecture: alpha amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el sparc sparc64
Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-bin (>= 1.2.3)
Recommends: gromacs
Suggests: gromacs-data
Replaces: gromacs-lam, gromacs-dev (<< 4.6.3-3~)
Breaks: gromacs-dev (<< 4.6.3-3~)
Description: Molecular dynamics sim, binaries for OpenMPI parallelization
 GROMACS is a versatile package to perform molecular dynamics, i.e. simulate
 the Newtonian equations of motion for systems with hundreds to millions of
 particles.
 .
 It is primarily designed for biochemical molecules like proteins and lipids
 that have a lot of complicated bonded interactions, but since GROMACS is
 extremely fast at calculating the nonbonded interactions (that usually
 dominate simulations) many groups are also using it for research on non-
 biological systems, e.g. polymers.
 .
 This package contains only the core simulation engine with parallel
 support using the OpenMPI interface.  It is suitable for nodes of a
 processing cluster, or for multiprocessor machines.

=== debian/rules ===
#!/usr/bin/make -f
#
# build script for GROMACS

# export DH_VERBOSE=1

PACKAGE := gromacs

# OpenMPI is only supported on a subset of architectures at this time.
# This list should remain synced with the Build-Depends and the Architecture
# line of gromacs-openmpi in debian/control.

OPENMPI_ARCH    = alpha amd64 armel armhf arm64 i386 ia64 powerpc powerpcspe ppc64 ppc64el sparc sparc64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 mips64 mips64el mips mipsel
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# add hardening flags, using dpkg-buildflags
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
#653916 and http://www.cmake.org/Bug/view.php?id=12928
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -Wall
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
endif

LDFLAGS += -Wl,--as-needed

COMMON_CONFIG_PARAMS = \
	$(CURDIR) \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_RULE_MESSAGES=OFF \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DGMX_X11=ON 

# Force compiler to use no more than SSE2 CPU optimizations, for broadest
# compatibility.  For local compilations, pass DEB_BUILD_OPTIONS=cpuopt
# for automatic detection of the best available option.  kfreebsd-* doesn't
# yet support the higher extensions anyhow, no special casing needed.
# See http://www.gromacs.org/Documentation/Acceleration_and_parallelization#Acceleration
ifeq  (,$(findstring cpuopt,$(DEB_BUILD_OPTIONS)))
ifneq (,$(findstring $(DEB_HOST_ARCH),i386 amd64))
	COMMON_CONFIG_PARAMS += -DGMX_SIMD=SSE2
endif
endif

# Include "gpu" in DEB_BUILD_OPTIONS to build GPU-accelerated binaries as well.
# This build option is not always well tested, please send comments.
# You must have the pacakges "nvidia-cuda-toolkit" and "nvidia-cuda-dev"
# installed. Those are not official build dependencies to keep the package in
# Debian main!
# Further details at http://www.gromacs.org/GPU_acceleration
GPU_CONFIG_PARAMS =
ifneq (,$(findstring gpu,$(DEB_BUILD_OPTIONS)))
	GPU_CONFIG_PARAMS += -DGMX_GPU=ON
endif

MPICH_CONFIG_PARAMS = \
	-DGMX_MPI=ON \
	-DGMX_X11=OFF \
	-DGMX_DEFAULT_SUFFIX=FALSE \
	-DGMX_BUILD_MDRUN_ONLY=TRUE

OPENMPI_CONFIG_PARAMS = \
	-DGMX_MPI=ON \
	-DGMX_DEFAULT_SUFFIX=FALSE \
	-DGMX_X11=OFF \
	-DCMAKE_EXE_LINKER_FLAGS="-L/usr/lib/openmpi/lib $(LDFLAGS)" \
	-DGMX_BUILD_MDRUN_ONLY=TRUE

# optional parallel build
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	(mkdir -p build/basic; cd build/basic; cmake $(COMMON_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMX_MPI=OFF -DBUILD_SHARED_LIBS=TRUE)
	(mkdir -p build/basic-dp; cd build/basic-dp; cmake $(COMMON_CONFIG_PARAMS) -DGMX_MPI=OFF -DBUILD_SHARED_LIBS=TRUE -DGMX_DOUBLE=ON)
	(mkdir -p build/mpich; cd build/mpich; CC=/usr/bin/mpicc.mpich CXX=/usr/bin/mpic++.mpich cmake \
	$(COMMON_CONFIG_PARAMS) $(MPICH_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMX_BINARY_SUFFIX="_mpi.mpich" -DGMX_LIBS_SUFFIX="_mpi.mpich")
	(mkdir -p build/mpich-dp; cd build/mpich-dp; CC=/usr/bin/mpicc.mpich CXX=/usr/bin/mpic++.mpich cmake \
	$(COMMON_CONFIG_PARAMS) $(MPICH_CONFIG_PARAMS) -DGMX_DOUBLE=ON -DGMX_BINARY_SUFFIX="_mpi_d.mpich" -DGMX_LIBS_SUFFIX="_mpi_d.mpich")
ifneq (,$(findstring $(DEB_HOST_ARCH),$(OPENMPI_ARCH)))
	(mkdir -p build/openmpi; cd build/openmpi; CC=/usr/bin/mpicc.openmpi CXX=/usr/bin/mpic++.openmpi cmake \
	$(COMMON_CONFIG_PARAMS) $(OPENMPI_CONFIG_PARAMS) $(GPU_CONFIG_PARAMS) -DGMX_BINARY_SUFFIX="_mpi.openmpi" -DGMX_LIBS_SUFFIX="_mpi.openmpi")
	(mkdir -p build/openmpi-dp; cd build/openmpi-dp; CC=/usr/bin/mpicc.openmpi CXX=/usr/bin/mpic++.openmpi cmake \
	$(COMMON_CONFIG_PARAMS) $(OPENMPI_CONFIG_PARAMS) -DGMX_DOUBLE=ON -DGMX_BINARY_SUFFIX="_mpi_d.openmpi" -DGMX_LIBS_SUFFIX="_mpi_d.openmpi")
endif
	touch $@


build: configure-stamp build-basic build-mpich build-openmpi

build-arch: build
build-indep: build

build-basic: configure-stamp
	dh_testdir
	$(MAKE) -C build/basic
	$(MAKE) -C build/basic-dp
	touch $@

build-mpich: configure-stamp
	dh_testdir
	$(MAKE) -C build/mpich
	$(MAKE) -C build/mpich-dp
	sed -e 's/#MPIABBR#/mpich/g' -e 's/#MPIPROG#/MPICH2/g' \
	    < debian/gromacs-parallel.README.Debian.in \
	    > debian/gromacs-mpich.README.Debian
	touch $@
	
build-openmpi: configure-stamp
	dh_testdir
ifneq (,$(findstring $(DEB_HOST_ARCH),$(OPENMPI_ARCH)))
	$(MAKE) -C build/openmpi
	$(MAKE) -C build/openmpi-dp
	sed -e 's/#MPIABBR#/openmpi/g' -e 's/#MPIPROG#/OpenMPI/g' \
	    < debian/gromacs-parallel.README.Debian.in \
	    > debian/gromacs-openmpi.README.Debian
endif
	touch $@	


clean: 
	dh_testdir
	dh_testroot
	rm -rf build
	dh_clean build-basic build-mpich build-openmpi configure-stamp \
	         debian/gromacs-mpich.README.Debian debian/gromacs-openmpi.README.Debian


install: build install-basic install-mpich install-openmpi
	dh_testdir
	dh_testroot
	dh_prep -pgromacs-data -pgromacs-dev
	
	dh_installdirs -pgromacs-data
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/top \
	   $(CURDIR)/debian/gromacs-data/usr/share/gromacs
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/html \
	   $(CURDIR)/debian/gromacs-data/usr/share/doc/gromacs
	mv $(CURDIR)/debian/gromacs/usr/share/man \
	   $(CURDIR)/debian/gromacs-data/usr/share/man
	# some of the default installation directories for documentation and
	# example shell scripts are not FHS-friendly; move them appropriately
	mv $(CURDIR)/debian/gromacs/usr/bin/GMXRC* \
	   $(CURDIR)/debian/gromacs/usr/bin/gmx-completion* \
	   $(CURDIR)/debian/gromacs-data/usr/share/gromacs/shell-specific
	chmod 644 $(CURDIR)/debian/gromacs-data/usr/share/gromacs/shell-specific/*
	dh_link -pgromacs-data usr/share/doc/gromacs/html usr/share/doc/gromacs-data/html
	dh_link -pgromacs-data usr/share/doc/gromacs/html usr/share/doc/gromacs-dev/html
	# this name is also give in documentation
	dh_link -pgromacs-data usr/share/doc/gromacs-data/copyright usr/share/doc/gromacs-data/COPYING
	# rename a pair of Perl scripts to drop the .pl extension (Policy 10.4)
	mv $(CURDIR)/debian/gromacs/usr/bin/demux.pl     $(CURDIR)/debian/gromacs/usr/bin/demux
	mv $(CURDIR)/debian/gromacs/usr/bin/xplor2gmx.pl $(CURDIR)/debian/gromacs/usr/bin/xplor2gmx

	dh_installdirs -pgromacs-dev
	mv $(CURDIR)/debian/gromacs/usr/include $(CURDIR)/debian/gromacs-dev/usr/include
	# catch normal libraries plus all applicable MPI variants
	mkdir -p $(CURDIR)/debian/gromacs-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	mv $(CURDIR)/debian/gromacs/usr/lib/$(DEB_HOST_MULTIARCH)/*.so \
	   $(CURDIR)/debian/gromacs/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
	   $(CURDIR)/debian/gromacs-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/template $(CURDIR)/debian/gromacs-dev/usr/share/gromacs/template
	# remaining documentation catch-all
	mv $(CURDIR)/debian/gromacs/usr/share/gromacs/* $(CURDIR)/debian/gromacs-data/usr/share/doc/gromacs
	-rmdir $(CURDIR)/debian/gromacs/usr/share/gromacs


install-basic: build
	dh_testdir
	dh_testroot
	dh_prep -pgromacs
	dh_installdirs -pgromacs
	$(MAKE) -C build/basic install DESTDIR=$(CURDIR)/debian/gromacs
	$(MAKE) -C build/basic-dp install DESTDIR=$(CURDIR)/debian/gromacs
	# In 5.0, these are removed commands with no documentation; delete symlinks too.
	rm $(CURDIR)/debian/gromacs/usr/bin/g_bond      \
	   $(CURDIR)/debian/gromacs/usr/bin/g_bond_d    \
	   $(CURDIR)/debian/gromacs/usr/bin/g_sgangle   \
	   $(CURDIR)/debian/gromacs/usr/bin/g_sgangle_d
	dh_installman -pgromacs debian/man/demux.1 debian/man/g_options.1 debian/man/gmx.1 debian/man/xplor2gmx.1
	# Here's a fun part.  In 5.0, "gmx command" replaced nearly all of the
	# "g_command" names, but the mapping is not 1:1 and some commands were
